c************ PROGRAM MAGNETOTELLURIC 1-D MODELLING **************
c***** PROGRAM READS RESISTIVITIES AND THICKNESS OF THE LAYERS****
C***** AND PRODUCES AN OUTPUT FILE WHICH YOU NAMED ***************
      common/coldat/em,c,t,rrco,nocol
      common/model/num,re(10),de(10)
      common/teoret/nt,eft(102),roateo(150),phateo(150)
      common/info/ncon
      print *,'tabaka says'
      read(*,*) num
      print *,'zdirenler'
      read(*,*)(re(jr),jr=1,num)
      print *,'tabaka kalnlklar'
      read(*,*)(de(jk),jk=1,num-1)
c     print *,'ro(w) kullanlsn m? 1=evet 0=hayr'
c     read(*,*) ncon
c     if(ncon.ne.1) go to 102
c     print *,'dispersif tabaka no.... m .... c ..... to..'
c     read(*,*) nocol,em,c,t
  102 continue
      call modteor()
c     if(ncon.ne.1) go to 304
c     write(2,218)
c 218 format(5x,'dsp.tbk.no.... m .... c ..... to..')
c     write(2,219) nocol,em,c,t
c 219 format(3x,i5,3f10.4)
  304 continue
      print *,'***  k dosyas adn giriniz*******'
      write(2,245)
  245 format(3x,'....zdirenler ...')
      write(2,248) (re(i),i=1,num)
      write(2,246)
  246 format(3x,'....kalnlklar........')
  248 format(2x,5f10.2)
      write(2,249) (de(i),i=1,num-1)
  249 format(5x,5f10.2)
      write(2,222)
  222 format(4x,'Frekans',5x,'Roah(ohm m.)',4x,'Phase(derece)',/)
      write(2,223)(eft(i),roateo(i),phateo(i),i=1,nt)
  223 format(3x,f16.5,2x,f10.3,2x,f10.4)
      stop
      end
      subroutine emped(n,f,ro,d,roa,phase)
      complex co,gam(20),z(20),gamd,game,gae1,gae2,zu,za
      dimension ro(20),d(20)
      pi=22./7.
      ome=2.*pi*f
      omemu=ome*4.*pi*1.0e-7
      co=cmplx(0.0,1.)
      ga=omemu/ro(n)
      gam(n)=co*ga
      gam(n)=csqrt(gam(n))
      z(n)=gam(n)*ro(n)
      n1=n-1
      do i=1,n1
         k=n1-i+1
          gam=0.0
           gamma=0.0
            gamma=omemu/ro(k)
           gam(k)=co*gamma
          gam(k)=csqrt(gam(k))
         gamd=gam(k)*d(k)
          game=cexp(-2.*gamd)
         gae1=1.-game
         gae2=1.+game
         zu=gam(k)*ro(k)*gae1+z(k+1)*gae2
         za=gam(k)*ro(k)*gae2+z(k+1)*gae1
         z(k)=gam(k)*ro(k)*(zu/za)
      end do
       ai=aimag(z(k))
       rea=real(z(k))
       phase=atan(-ai/rea)*180/pi
       phase=abs(phase)
c      phase=90.-phase
       emp=cabs(z(k))
       emp2=emp*emp
       roa=(1./omemu)*emp2
      return
      end
      subroutine modteor()
      common/info/ncon
      common/teoret/nt,eft(102),roateo(150),phateo(150)
      common/model/num,re(10),de(10)
      common/coldat/em,c,t,rrco,nocol
      data eft/0.0001,0.000125,0.00015,0.0002,0.00025,0.0003,0.0004,
     *0.0005,0.0006,0.0007,0.0008,0.0009,0.001,0.00125,0.0015,
     *0.00175,0.002,0.0025,0.003,0.004,
     a0.005,0.006,0.007,0.008,0.01,0.0125,0.015,0.0175,0.02,0.025,
     b0.03,0.04,0.05,0.06,0.07,0.08,0.1,0.125,0.15,0.175,0.2,0.25,
     c0.3,0.4,0.5,0.6,0.7,0.8,1.0,1.25,1.5,1.75,2.0,2.5,3.0,4.0,5.0,
     d6.0,7.0,8.0,10.0,12.5,15.0,20.0,25.0,30.0,40.0,50.0,60.0,70.0,
     e80.0,100.,125.,150.,200.,250.,300.,400.,500.,600.,700.,1000.,
     f1250.,1500.,2000.,2500.,3000.,4000.,5000.,6000.,7000.,8000.,
     g10000.,15000.,20000.,30000.,40000.,50000.,60000.,70000.,80000.,
     h100000./
      nolay=nocol
      nt=102
      if(ncon.ne.1) go to  866
      rrco=re(nocol)
      reap=re(nocol)
  866 continue
      do jk=1,nt
      fif=eft(jk)
      fcol=fif
      if(ncon.ne.1) go to 666
      rhmc=rocol(fcol)
      re(nocol)=rhmc
  666 call emped(num,fif,re,de,roateo(jk),phateo(jk))
      end do
      if(ncon.eq.1) re(nocol)=reap
      return
      end
      function rocol(f)
      common/coldat/em,c,t,rrco,nocol
      complex z,df,edf,payda
      z=cmplx(0.0,0.0)
      pi=22./7.                  !pi hesaplanyor
      pi2=2.*pi
        df=cmplx(0.0,0.0)
         edf=cmplx(0.0,0.0)
************ w(acisal frekans hesaplaniyor ) *************************c
          w=pi2*f
*************  R(w)  hesaplaniyor   **********************************c
             cpr=w*t
              df=cmplx(0.0,cpr)
              edf=df**c
             payda=1.+edf
            z=(1.-1./payda)*em
           z=rrco*(1-z)
*************  R(w) 'nin  gercel ve sanal kisimlari aliniyor  ********c
          rz=real(z)
         aiz=aimag(z)
************* faz  ve genlik hesaplaniyor       **********************c
        faz=atan(aiz/rz)*1000.
       amp=cabs(z)
        rocol=amp
*************************  yazdirma islemi  **************************c
      return
      end
